
void move_smooth(int pinA, int pinB, int pinC, int pinD){

  float f_carrier = 4000;   //pwm freq in Hz
  float motor_rpm = 10;    //motor speed in revolutions per minute (for 1.8 degree/step motor) 
  
  digitalWrite(pinA, HIGH);
  digitalWrite(pinB, HIGH); 
  digitalWrite(pinC, HIGH); 
  digitalWrite(pinD, HIGH);  //disable all pins

  int on_timeA = 0; //on-times in microseconds
  int on_timeB = 0;
  int on_timeC = 0;
  int on_timeD = 0;

  float pulse_time = 1000000 / f_carrier;
  float step_time = 1000000 / (motor_rpm * 200 / 60);

  
  
  for(int i=0;i<(step_time / pulse_time * 4);i++){

    on_timeA = 0;
    on_timeB = 0;
    on_timeC = 0;
    on_timeD = 0;

    on_timeA = pulse_time * cos((3.14 / (step_time / pulse_time)) * i);
    if(on_timeA < 0){
      on_timeA = 0;
    }

    on_timeB = pulse_time * sin((3.14 / (step_time / pulse_time)) * i);
    if(on_timeB < 0){
      on_timeB = 0;
    }

    on_timeC = -pulse_time * cos((3.14 / (step_time / pulse_time)) * i);
    if(on_timeC < 0){
      on_timeC = 0;
    }

    on_timeD = -pulse_time * sin((3.14 / (step_time / pulse_time)) * i);
    if(on_timeD < 0){
      on_timeD = 0;
    }

    

    digitalWrite(pinA, LOW);
    digitalWrite(pinB, LOW); 
    digitalWrite(pinC, LOW); 
    digitalWrite(pinD, LOW);  //enable all

    long start = micros();
    long finish = 0;

    while(finish - start < pulse_time){ 

      finish = micros();
      
      if(finish - start >= on_timeA){
        digitalWrite(pinA, HIGH);
      }
      if(finish - start >= on_timeB){
        digitalWrite(pinB, HIGH);
      }
      if(finish - start >= on_timeC){
        digitalWrite(pinC, HIGH);
      }
      if(finish - start >= on_timeD){
        digitalWrite(pinD, HIGH);
      }
        
    }

  }


  
}
