#include <LowPower.h>


bool rotation_d = true;  //direction of rotation
float current = 0;        //stores the measured current
float prev_current = 0;    //stores the previous measurement

void setup() {
  Serial.begin(9600);
  
  pinMode(8, OUTPUT);
  pinMode(9, OUTPUT);
  pinMode(10, OUTPUT);
  pinMode(11, OUTPUT);

  digitalWrite(8, HIGH);
  digitalWrite(9, HIGH);
  digitalWrite(10, HIGH);
  digitalWrite(11, HIGH);

  delay(5000);  //5 second start up delay

}

void loop() {

  current = detect_current();

  if(current > 513.20){  //not in amps, the sensor output is 512 - 1023 for positive current from 0 to 20A
    
    for(int j=0;j<20;j++){  //run tracking process with 20 movements
    
      current = detect_current();  //get the current at this moment
      
      if(current > prev_current + 0.05){   //if the current has increased sigificantly
        move_motor(rotation_d);      //keep moving in this direction
        prev_current = current; 
      }
    
      else{       
        rotation_d = !rotation_d; //reverse direction
        move_motor(rotation_d);   //move back
        prev_current = current;
        
      }
  
    }
  }

  
  //go to sleep for 112 * 8 seconds (~15 minutes)
  for(int k=0;k<112;k++){
    LowPower.powerDown(SLEEP_8S, ADC_OFF, BOD_OFF);
  }

}
